-- ============================================
-- =                                          =
-- =          Crate SENT by Mahalis           =
-- =                                          =
-- ============================================

include('shared.lua')

local pinchMat = Material("effects/strider_pinch_dudv") -- spawning effect
local pinchSprite = Material("sprites/strider_blackball")
local bulgeMat = Material("effects/strider_bulge_dudv") -- destroying effect
local bulgeSprite = Material("sprites/blueglow1")

ENT.refPinAmt = 0.5
ENT.refBulAmt = 1
ENT.tip = ""

language.Add("Undone_CrateSpawn","Crate Spawn Undone")
language.Add("Cleanup_CrateSpawn","Crate Spawn")
language.Add("Cleaned_CrateSpawn","Cleaned up all Crate spawns")

function ENT:Initialize()
	-- client-side, so nothing happens here
	
end

function ENT:GetCenterPos()
	if self.modelName == "models/items/item_item_crate.mdl" then
		return self.Entity:GetPos() + self.Entity:GetAngles():Up()*12.3
	end
	return self.Entity:GetPos()
end

function ENT:Draw()
	if !(self.Entity:GetNetworkedBool("dying")) then
		if self.refPinAmt > 0 then -- still spawning; refract
			pinchMat:SetMaterialFloat("$refractamount",self.refPinAmt)
			render.SetMaterial(pinchMat)
			render.UpdateRefractTexture()
			render.DrawSprite(self:GetCenterPos(),96,96)
			
			render.SetMaterial(pinchSprite)
			render.DrawSprite(self:GetCenterPos(),192*self.refPinAmt,192*self.refPinAmt)
		else -- it's done spawning; this is where it draws normally
			if LocalPlayer():GetEyeTrace().Entity == self.Entity && EyePos():Distance( self.Entity:GetPos() ) < 512 && self.cratedPlayer != LocalPlayer() then
				self:DrawEntityOutline( 1.0 )
				if self.tip != "no" then AddWorldTip(self.Entity:EntIndex(),self.tip,0.5,self.Entity:GetPos(),self.Entity) end
			end
		end
		self.Entity:DrawModel()
	else
		if self.refBulAmt > 0 then -- it's breaking
			bulgeMat:SetMaterialFloat("$refractamount",self.refBulAmt)
			render.SetMaterial(bulgeMat)
			render.UpdateRefractTexture()
			render.DrawSprite(self:GetCenterPos(),64*(4-3*self.refBulAmt),64*(4-3*self.refBulAmt)) -- die-effect grows over time
			
			render.SetMaterial(pinchSprite)
			render.DrawSprite(self:GetCenterPos(),128*(1-self.refBulAmt),128*(1-self.refBulAmt))--,Color(96,160,255))
		end
	end
end

function ENT:Think()
	if self.tip == "" then self.tip = self.Entity:GetNetworkedString("tip") end
	if !self.Entity:GetNetworkedBool("dying") then
		-- fade out spawn refraction over first not-many seconds
		if self.refPinAmt > 0 then self.refPinAmt = self.refPinAmt - FrameTime() end
		if self.refPinAmt < 0 then self.refPinAmt = 0 end
	else
		-- ditto, but for destroyed-refraction
		if self.refBulAmt > 0 then self.refBulAmt = self.refBulAmt - 4*FrameTime() end
		if self.refBulAmt < 0 then self.refBulAmt = 0 end
	end
end