-- ============================================
-- =                                          =
-- =          Crate SENT by Mahalis           =
-- =                                          =
-- ============================================

AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
include('shared.lua')

ENT.bPunted = false

ENT.entType = ""
ENT.modelName = ""
ENT.aHealth = 25
ENT.aModel = "models/items/item_item_crate.mdl"
ENT.udOwnr = 1
ENT.npcWep = ""
ENT.npcCitType = "1"
ENT.npcCitMed = 0
ENT.entSkin = 0
ENT.gib = 1
ENT.brkOnUse = 1
ENT.showTip = 1

ENT.cratedPlayer = nil

ENT.dieTime = 1 -- countdown for self-removal

function ENT:Initialize()
	-- standard physics setup
	self.Entity:SetModel(self.aModel)
	self.Entity:PhysicsInit(SOLID_VPHYSICS)
	self.Entity:SetMoveType(MOVETYPE_VPHYSICS)
	self.Entity:SetSolid(SOLID_VPHYSICS)
	local phys = self.Entity:GetPhysicsObject()
	if(phys:IsValid()) then phys:Wake() end
	self.Entity:SetNetworkedBool("dying",false,false) -- we use this later when the crate's destroyed
	util.PrecacheSound("Buttons.snd9")
	util.PrecacheSound("NPC_CombineBall.Launch")
	if self.showTip == 1 then
		self.Entity:SetNetworkedString("tip",self:GetTipStr())
	else
		self.Entity:SetNetworkedString("tip","no")
	end
end

function ENT:GetTipStr()
	local typ = self.entType
	local mdl = self.modelName
	local ply = self.cratedPlayer
	if ply != nil then return ply:GetName() end
	if typ == "prop_physics" then return "Prop: " .. string.sub(mdl,8) end
	
	-- NPCs
	
	-- allies
	if typ == "npc_citizen" then return "Citizen" end
	if typ == "npc_alyx" then return "Alyx" end
	if typ == "npc_barney" then return "Barney" end
	if typ == "npc_vortiguant" then return "Vortiguant" end
	if typ == "npc_mossman" then return "Dr. Mossman" end
	if typ == "npc_monk" then return "Father Grigori" end
	if typ == "npc_kleiner" then return "Dr. Kleiner" end
	if typ == "npc_dog" then return "D0g" end
	if typ == "npc_eli" then return "Eli" end
	
	-- combine
	if typ == "npc_combine_s" then
		if mdl == "models/combine_super_soldier.mdl" then return "Combine Elite" end
		if mdl == "models/combine_soldier_prisonguard.mdl" then return "Nova Prospekt Guard" end
		return "Combine Soldier"
	end
	if typ == "npc_metrocop" then return "Metrocop" end
	if typ == "npc_breen" then return "Breen" end
	
	-- zombies and such
	if typ == "npc_zombie" then return "Zombie" end
	if typ == "npc_fastzombie" then return "Fast Zombie" end
	if typ == "npc_poisonzombie" then return "Poison Zombie" end
	if typ == "npc_headcrab" then return "Headcrab" end
	if typ == "npc_headcrab_fast" then return "Fast Headcrab" end
	if typ == "npc_headcrab_black" then return "Poison Headcrab" end
	if typ == "npc_zombie_torso" then return "Zombie Torso" end
	if typ == "npc_fastzombie_torso" then return "Fast Zombie Torso" end
	
	-- combine synths
	if typ == "npc_combinedropship" then return "Dropship" end
	if typ == "npc_combinegunship" then return "Gunship" end
	if typ == "npc_strider" then return "Strider" end
	
	-- combine machines
	if typ == "npc_cscanner" then return "Scanner" end
	if typ == "npc_manhack" then return "Manhack" end
	if typ == "npc_rollermine" then return "Rollermine" end
	if typ == "npc_turret_floor" then return "Floor Turret" end
	if typ == "npc_helicopter" then return "Hunter-Chopper" end
	
	-- antlions
	if typ == "npc_antlion" then return "Antlion" end
	if typ == "npc_antlionguard" then return "Antlion Guard" end
	
	-- other
	if typ == "npc_gman" then return "GMan" end
	if typ == "npc_crow" then return "Crow" end
	if typ == "npc_pigeon" then return "Pigeon" end
	if typ == "npc_seagull" then return "Seagull" end
	if typ == "npc_barnacle" then return "Barnacle" end
	
	return typ
end

function ENT:GetCenterPos()
	if self.modelName == "models/items/item_item_crate.mdl" then
		return self:GetPos() + self:GetAngles():Up()*12.3
	end
	return self:GetPos()
end

function ENT:StartSound()
	self.Entity:EmitSound("Buttons.snd9",200,70)
end



-- duplicator code doesn't work yet; needs to go in STool

--function mkCrate(ply,Pos)
--	local nuCrate = ents.Create("m_crate")
--	if !(nuCrate:IsValid()) then return false end
--	nuCrate:SetPos(Pos)
--	local ncTable = {entType = self.entType, modelName = self.modelName, udOwnr = ply, npcWep = self.npcWep, npcCitType = self.npcCitType, npcCitMed = self.npcCitMed, entSkin = self.entSkin}
--	table.Merge(nuCrate:GetTable(),ncTable)
--	nuCrate:Spawn()
--	return nuCrate
--end

--duplicator.RegisterEntityClass("m_crate",mkCrate,"Pos")

function ENT:OnTakeDamage(dmg)
	-- simulate health
	self.aHealth = self.aHealth - dmg:GetDamage()
	if self.aHealth <= 0 then
		self:Breakify()
	end
end

function gravgunDrop(ply, target)
	if ply:KeyDown(IN_ATTACK) && target:GetClass() == "m_crate" then
		target:Punted()
	end
	return true
end
  
hook.Add( "GravGunOnDropped", "gravgunDrop", gravgunDrop ) 

function ENT:Breakify()
	if self.cratedPlayer != nil then
		--self.cratedPlayer:SpectateEntity(nil)
		--self.cratedPlayer:UnSpectate()
		local phy = self.Entity:GetPhysicsObject()
		phy:EnableMotion(false)
		self.Entity:SetSolid(SOLID_NONE)
		self.cratedPlayer:DrawViewModel(true)
		self.cratedPlayer:DrawWorldModel(true)
		self.cratedPlayer:Spawn()
		self.cratedPlayer:SetPos(self.Entity:GetPos()+Vector(0,0,16))
		--self.cratedPlayer:CrosshairEnable()
	else
		if self.entType == "" then return end -- if there's no entity set, we've been spawned in some bad way, so no breakage
		local nuEnt = ents.Create(self.entType) -- create the entity
		util.PrecacheModel(self.modelName) -- precache the model
		nuEnt:SetModel(self.modelName) -- and set it
		local spawnPos = self:GetPos()+Vector(0,0,nuEnt:BoundingRadius()) -- position to spawn it
		
		nuEnt:SetPos(spawnPos) -- position
		if string.find(self.entType,"npc_") != 1 then
			nuEnt:SetAngles(self:GetAngles()) -- orient with crate if we're not an NPC; they don't do well not-upright
		end
		nuEnt:SetSkin(self.entSkin)
		
		if self.npcWep != "" then -- if it's an NPC and we found a weapon for it when it was spawned, then
			nuEnt:SetKeyValue("additionalequipment",self.npcWep) -- give it the weapon
		end
		
		if self.entType == "npc_citizen" then
			nuEnt:SetKeyValue("citizentype",self.npcCitType) -- set the citizen type - rebel, refugee, etc.
			if self.npcCitType == "3" && self.npcCitMed==1 then -- if it's a rebel, then it might be a medic, so check that
				nuEnt:SetKeyValue("spawnflags","131072") -- set medic spawn flag
			end
		end
		
		if self.entType == "prop_physics" then
			nuEnt:SetPhysicsAttacker(self.udOwnr) -- should, in theory, give you kill-credit for dropping a cargo container on someone
		end
		
		nuEnt:Spawn()
		nuEnt:Activate()
		-- undo stuff
		undo.Create("CrateSpawn") 
			undo.AddEntity(nuEnt)
			undo.SetPlayer(self.udOwnr)
		undo.Finish()
	end
	self.Entity:EmitSound("NPC_CombineBall.Launch",160,80)
	
	if self.gib == 1 then self:SpawnGibs() end
	
	-- start opening animation
	self:Die()
end

function ENT:PhysicsCollide(data,physobj)
	-- we hit something - was it because of the ggun?
	if self.bPunted then self:Breakify() end
end

function ENT:Punted()
	self.bPunted = true -- lets PhysicsCollide know about a punt
end

function ENT:SpawnGibs()
	local breakProp = ents.Create("prop_physics") -- create a dummy prop
	breakProp:SetModel(self.aModel) -- with our model
	breakProp:SetPos(self:GetPos()) -- put it where we are
	breakProp:SetName("gibee") -- for later restrictioning of physex
	breakProp:Spawn() -- and spawn
	-- don't let it move, or we might get weird out-of-sync-ness
	local brkPhys = breakProp:GetPhysicsObject()
	if brkPhys:IsValid() then
		brkPhys:EnableGravity(false)
		brkPhys:EnableDrag(false)
		brkPhys:EnableCollisions(false)
	end
	-- make a physics explosion to push the gibs away
	local phyEx = ents.Create("env_physexplosion")
	phyEx:SetPos(self:GetCenterPos())
	phyEx:SetKeyValue("magnitude","25000")
	phyEx:SetKeyValue("targetentityname","gibee") -- only affects dummy prop
	phyEx:SetKeyValue("spawnflags",1)
	phyEx:Spawn()
	breakProp:Fire("break","",0) -- this will spawn the gibs, but the original model will still be visible
	phyEx:Fire("explode","",0)
	breakProp:Remove() -- so remove the original
	phyEx:Remove() -- and we're done with the physexplosion too
end

function ENT:Die()
	self.Entity:SetNetworkedBool("dying",true,true) -- let the client know to play the animation
	-- make the model go away without actually removing the object
	self.Entity:SetMoveType(MOVETYPE_NONE)
	self.Entity:SetSolid(SOLID_NONE)
	self.Entity:DrawShadow(false)	
end

function ENT:Use(activator,caller)
	if self.brkOnUse == 1 then self:Breakify() end
end

function ENT:Think()
	if self.Entity:GetNetworkedBool("dying") then
		self.dieTime = self.dieTime - .4 -- makes it sort-of-sync with the client-side animation
		if self.dieTime <= 0 then
			self.Entity:Remove()
		end
	end
end

