-- ============================================
-- =                                          =
-- =      Crate Maker STOOL by Mahalis        =
-- =                                          =
-- =     Version, thanks, and suchlike        =
-- =       in the SEnt's shared.lua           =
-- =                                          =
-- ============================================

-- === SERVER ADMINS: Change this to allow/disallow player crating. "all" for everyone; "admin" for admin-only; "none" for nobody.

TOOL.alwPlyCrate = "all"

-- You can use the server command "cm_allowplayers" to change this from the console, but the setting will not persist from one match to another.

-- === DO NOT CHANGE BELOW THIS LINE UNLESS YOU REALLY, REALLY KNOW WHAT YOU'RE DOING ===


TOOL.Category = "Other"
TOOL.Name = "#Crate Maker"
TOOL.Command = nil
TOOL.ConfigName = ""

TOOL.ClientConVar["cmodel"] = "models/items/item_item_crate.mdl"
TOOL.ClientConVar["chealth"] = "25"
TOOL.ClientConVar["gib"] = "1"
TOOL.ClientConVar["brkOnUse"] = "1"
TOOL.ClientConVar["showTip"] = "1"

cleanup.Register('Crate')

if CLIENT then

	language.Add( "cratemaker", "Crate Maker" )
	language.Add( "Tool_cratemaker_name", "Crate Maker" )
	language.Add( "Tool_cratemaker_desc", "Crate stuff" )
	language.Add( "Tool_cratemaker_0", "Left click to create a crate around something." )
	language.Add("Undone_Crate","Crate Undone")
	language.Add("Cleanup_Crate","Crate")
	language.Add("Cleaned_Crate","Cleaned up all Crates")
end

if SERVER then
	function setAllows(ply,cmd,args)
		if args == "none" || args == "admin" then
			self.alwPlyCrate = args
		end
	end
	
	function getAuto(cmd,args)
		return {"all","admin","none"}
	end
	concommand.Add("cm_allowplayers",setAllows,getAuto)
end

function TOOL:LeftClick(trace)
	if(CLIENT) then return true end
	if !(trace.Entity && trace.Entity:IsValid() && trace.Entity:EntIndex() != 0 && (trace.Entity:GetClass() != "m_crate")) then return false end-- || (trace.Entity:GetClass() == "m_crate" && trace.Entity:GetModel() != self:GetClientInfo("cmodel")))) then return false end
	local pos = trace.Entity:GetPos()
	local crate = ents.Create("m_crate") -- spawn the actual crate
	crate:SetPos(pos) -- and position it
	
	if !trace.Entity:IsPlayer() then -- not a player; crate normally
		local eSkin = trace.Entity:GetSkin()
		local foundWep = ""
		if string.find(trace.Entity:GetClass(),"npc_") == 1 then -- it's an npc, so check for weapons
			local nearEnts = ents.FindInSphere(pos,4)  -- NPC weapons are at the center, so a radius of 0.000001 would still work, but just to be safe...
			for eKey, eVal in pairs(nearEnts) do -- loop through all entities found within the sphere
				if string.find(eVal:GetClass(),"weapon_") == 1 then -- if it's a weapon
					foundWep = eVal:GetClass() -- hooray, we found it; set
				end
			end
		end
		local citType = "" -- citizen type
		local citMed = 0 -- is it a medic? assume no
		if trace.Entity:GetClass() == "npc_citizen" then
			citType = string.sub(trace.Entity:GetModel(),21,21) -- get group number (e.g. models/humans/group0#/whatever)
			if string.sub(trace.Entity:GetModel(),22,22) == "m" then citMed = 1 end -- medic skins have an "m" after the number
		end
		
		
		local sets = {aModel=self:GetClientInfo("cmodel"),aHealth=self:GetClientNumber("chealth"),entType = trace.Entity:GetClass(),modelName = trace.Entity:GetModel(),udOwnr = self:GetOwner(),npcWep = foundWep,npcCitType = citType,entSkin = eSkin, npcCitMed = citMed,gib = self:GetClientNumber("gib"),brkOnUse = self:GetClientNumber("brkOnUse"),showTip = self:GetClientNumber("showTip")} -- create the table of crate-settings
		table.Merge(crate:GetTable(),sets) -- and apply the settings
		
		-- don't let people undo player-crating; that'll just mess stuff up
		undo.Create("Crate")
			undo.AddEntity(crate)
			undo.SetPlayer(self:GetOwner())
		undo.Finish()
		
		trace.Entity:Remove() -- remove the original object
		crate:Spawn()
	else -- yes a player; spectate
		if self:GetOwner():IsAdmin() || self.alwPlyCrate == "all" then
			local ply = trace.Entity
			ply:StripWeapons()
			ply:DrawViewModel(false)
			ply:DrawWorldModel(false)
			ply:Spectate(OBS_MODE_CHASE)
			ply:SpectateEntity(crate)
			local sets = {cratedPlayer=ply}
			table.Merge(crate:GetTable(),sets)
			crate:Spawn()
		else
			crate:Remove()
			crate = nil
			return false
		end
	end
	
	return true
end

function TOOL.BuildCPanel(CPanel)
	CPanel:AddControl("Header",{Text = "#Tool_cratemaker_name","#Tool_cratemaker_desc"})
	local params = {Label = "Crate model", MenuButton = "0", Options = {}}
	params.Options["Smaller Pokeball"] = {cratemaker_cmodel = "models/dummer/pokeball/pokeball1.mdl"}
	params.Options["Bigger Pokeball"] = {cratemaker_cmodel = "models/dummer/pokeball/pokeball.mdl"}
	params.Options["Item Crate"] = {cratemaker_cmodel = "models/items/item_item_crate.mdl"}
	params.Options["Small Crate"] = {cratemaker_cmodel = "models/props_junk/wood_crate001a.mdl"}
	params.Options["Large Crate"] = {cratemaker_cmodel = "models/props_junk/wood_crate002a.mdl"}
	params.Options["Milk Carton"] = {cratemaker_cmodel = "models/props_junk/garbage_milkcarton002a.mdl"}
	params.Options["Cardboard Box 1a"] = {cratemaker_cmodel = "models/props_junk/cardboard_box001a.mdl"}
	params.Options["Cardboard Box 1b"] = {cratemaker_cmodel = "models/props_junk/cardboard_box001b.mdl"}
	params.Options["Cardboard Box 2a"] = {cratemaker_cmodel = "models/props_junk/cardboard_box002a.mdl"}
	params.Options["Cardboard Box 2b"] = {cratemaker_cmodel = "models/props_junk/cardboard_box002b.mdl"}
	params.Options["Cardboard Box 3a"] = {cratemaker_cmodel = "models/props_junk/cardboard_box003a.mdl"}
	params.Options["Cardboard Box 3b"] = {cratemaker_cmodel = "models/props_junk/cardboard_box003b.mdl"}
	params.Options["Cardboard Box 4"] = {cratemaker_cmodel = "models/props_junk/cardboard_box004a.mdl"}
	CPanel:AddControl("ComboBox",params)
	CPanel:AddControl("Slider",{Label = "Crate health",	Type = "Int", Min = 1, Max = 500, Command = "cratemaker_chealth"})
	--CPanel:AddControl("Checkbox",{Label = "Crate gibs", Command = "cratemaker_gib"})
	CPanel:AddControl("Checkbox",{Label = "Crate break on Use", Command = "cratemaker_brkOnUse"})
	CPanel:AddControl("Checkbox",{Label = "Show info tip", Command = "cratemaker_showTip"})
end