if not ( RES_DISTRIB == 2 ) then Error("Please Install Resource Distribution 2 Addon.'" ) return end

TOOL.Category = '(Resource Dist.)'
TOOL.Name = '#Smart Link Tool'
TOOL.Command = nil
TOOL.ConfigName = ''
if (CLIENT and GetConVarNumber("RD_UseLSTab") == 1) then TOOL.Tab = "Life Support" end



--the default smartlink settings
TOOL.ClientConVar["radius"]=128
TOOL.ClientConVar["nocollideradius"]=128
TOOL.ClientConVar["unfreeze"]=0
TOOL.ClientConVar["autofreeze"]=1




--edit these variables to customise your install

--when linking over time, linktime is the gap between successive links/nocollides
WELDTIME=0.01
--notifygap is the multiple of which the player will be informed of the smartlink progress (ie. link 50, 100, 150 placed)
NOTIFYGAP=50
--slowmode is linking over time.  Turning this off will make smart linker perform the link in one go, making it more likely to crash with big contraptions
SLOWMODE=true
--if you have this on, the script will attempt to follow Conna's prop protection scheme
USEPROPPROTECTION=false

if ( CLIENT ) then

	language.Add( "Tool_smartlinker_name", "Smart Linker" )
	language.Add( "Tool_smartlinker_desc", "Automatically links selected props" )
	language.Add( "Tool_smartlinker_0", "Left Click: Selects Props to be Linked (hold use key to auto-select). \n Right Click: Generates the links (hold use to link to one prop). \n Reload: Clears all links from selected prop.")


	language.Add( "Undone_smartlink", "Undone Smart Link" )

end


function TOOL:LeftClick( trace )

	if(!self.busy) then
    if(self.props==nil) then
	      self.props={}
	end
	
	for a,v in ipairs(self.props) do
			--Msg("V="..v.."\n")
			if(!v.ent:IsValid()) then
				table.remove(self.props,a)
				--Msg("Removing...\n")
			end
	end
    --Msg("Start\n")
	if (!trace.HitPos) then return false end
	if (trace.Entity:IsPlayer()) then return false end
	
	if ( SERVER && !util.IsValidPhysicsObject( trace.Entity, trace.PhysicsBone ) ) then return false end
	
	if ( CLIENT ) then return true end
	
	// Get client's CVars
	local ply = self:GetOwner()
	
	local radius=self:GetClientNumber("smartlinker_radius") == 1000
	local nocollideradius=self:GetClientNumber("nocollideradius")
	local randomlinks = self:GetClientNumber("randomlinks")
	local smartnocollide = self:GetClientNumber("nocollide") == 1
	local linksperprop = self:GetClientNumber("maxlinkspp") == 10
	
	if ( trace.Entity:IsValid() && trace.Entity:GetPhysicsObject():IsValid()) then
	   if(ply:KeyDown(IN_USE)||ply:KeyDown(IN_SPEED)) then
	   
	        --autoselect
	        
			local selectedcount=self:Autoselect(trace.Entity,radius)
			if(selectedcount>1) then
		    self:GetOwner():PrintMessage(HUD_PRINTCENTER,selectedcount.." props auto-selected")
		    end
	   
       else
	
	   	   self:ChooseEnt(trace.Entity)
	   end
	end
	--Msg("End\n")
	return true
	else
	return false
	end
	
end

function TOOL:Autoselect(ent,radius)
		 local counted=0
         if ( ent:IsValid() && ent:GetPhysicsObject():IsValid() && !ent:IsPlayer()) then

            if(!self:IsSelected(ent)) then
            
                if(self:IsPropOwner(self:GetOwner(),ent)) then
                
                --add to list, try adding everything near it to list
            	self:SelectEnt(ent,false)
            	counted=1
            	
            	local close_ents = ents.FindInSphere( ent:GetPos(), radius )
            	
            	for i,v in ipairs(close_ents) do
            	    if(v!=ent) then
            	        counted=counted+self:Autoselect(v,radius)
            	    end
            	end
            	end
			end
         end
         return counted
end

function TOOL:IsSelected(ent)

    	 local selected=-1
       for i,v in ipairs(self.props) do
           if(v.ent==ent) then
		   selected=i
		   break
		   end
	   end
	   
	   if(selected==-1) then
	        return false
		else
		    return true
	   end

end

--Based on a function by Conna
function TOOL:IsPropOwner(ply, ent)

	if(USEPROPPROTECTION) then
	for k, v in pairs(g_SBoxObjects) do
		for b, j in pairs(v) do
			for _, e in pairs(j) do
				if(e == ent) then
					if(k == ply:UniqueID()) then
						return true
					end
				end
			end
		end
	end

	for k, v in pairs(GAMEMODE.CameraList) do
		for b, j in pairs(v) do
			if(j == ent) then
				if(k == ply:UniqueID()) then
					return true
				end
			end
		end
	end
	return false
	else
	return true
	end
end

function TOOL:ChooseEnt(ent)

		  if(self:IsPropOwner(self:GetOwner(),ent)) then
		  
	         local selected=-1
	       for i,v in ipairs(self.props) do
	           if(v.ent==ent) then
			   selected=i
			   break
			   end
		   end
	         if(selected==-1) then
		       --Msg("Setting colour\n")
		       local r,g,b,a = ent:GetColor();
			   table.insert(self.props,{ent=ent,r=r,g=g,b=b,a=a})
			   ent:SetColor(0,255,0,255)
		   else
			   ent:SetColor(self.props[selected].r,self.props[selected].g,self.props[selected].b,self.props[selected].a)
			   table.remove(self.props,selected)
		   end
	   end
end

function TOOL:DeselectEnt(ent)

         if(self:IsPropOwner(self:GetOwner(),ent)) then
         local selected=-1
       for i,v in ipairs(self.props) do
           if(v.ent==ent) then
		   selected=i
		   break
		   end
	   end
         if(selected==-1) then

	   else
       	   ent:SetColor(self.props[selected].r,self.props[selected].g,self.props[selected].b,self.props[selected].a)
		   table.remove(self.props,selected)
	   end
	   end
end

function TOOL:SelectEnt(ent)

   if(self:IsPropOwner(self:GetOwner(),ent)) then
    local r,g,b,a = ent:GetColor();
	table.insert(self.props,{ent=ent,r=r,g=g,b=b,a=a})
	ent:SetColor(0,255,0,255)
   end

end

function TOOL:LinkingFinished(unfreeze, linkcount, holdinguse, proptable,ply)
		 undo.SetPlayer( ply )
			undo.Finish()

			--if set to auto unfreeze
			if(unfreeze) then

				 for a,v in ipairs(proptable) do
				     if(v.ent:IsValid()) then
						 local entphys=v.ent:GetPhysicsObject()
						 if(entphys:IsValid()) then
						        entphys:EnableMotion(true)
						        entphys:Wake()
						 end
					 end
				 end

			end
			


			if(holdinguse) then
			    if(linkcount!=1) then
      				self:GetOwner():PrintMessage(HUD_PRINTCENTER,"Link to prop complete! "..linkcount.." links placed")
		    	else
      			self:GetOwner():PrintMessage(HUD_PRINTCENTER,"Link to prop complete! "..linkcount.." link placed")
		    	end

			else

				if(linkcount!=1) then
			    self:GetOwner():PrintMessage(HUD_PRINTCENTER,"Smart-link complete! "..linkcount.." links placed")
			    else
			    self:GetOwner():PrintMessage(HUD_PRINTCENTER,"Smart-link complete! "..linkcount.." link placed")
			    end
		    end
		    
		    --deselect
		    self.busy=false
		    self:ResetSelection()
		    
		    --Msg("Smart-link complete!\n")
end

function TOOL:LinkEnts(ent1, ent2,bone1, bone2)

		local material	= self:GetClientInfo( "material" )
		local width		= self:GetClientNumber( "width" ) 
		local color		= Color(self:GetClientNumber("color_r"), self:GetClientNumber("color_g"), self:GetClientNumber("color_b"))
		

    Dev_Link(ent1, ent2, bone1, bone2, material, color, linkcount)

end

function TOOL:RightClick( trace )
	if(self.busy) then
	
	else
	
	local ply = self:GetOwner()
	
	local autofreeze = self:GetClientNumber("autofreeze") == 1
	local unfreeze = self:GetClientNumber("unfreeze") == 1
	
	if(self.props!=nil) then
	
		for a,v in ipairs(self.props) do
			--Msg("V="..v.."\n")
			if(!v.ent:IsValid()) then
				table.remove(self.props,a)
				--Msg("Removing...\n")
			end
		end
		
		if(#self.props>1) then
		
		
		    self.busy=true
		    --prefreeze
		    
			if(autofreeze) then

				 for a,v in ipairs(self.props) do
					 local entphys=v.ent:GetPhysicsObject()
					 if(entphys:IsValid()) then
					        entphys:EnableMotion(false)
					        entphys:Sleep()
					 end
				 end

			end
		
		
		
		
	        undo.Create("smartlink")

			local links={}
			for a,v in ipairs(self.props) do
				links[a]={}
			end

			local linkcount=0
			local holdinguse=false

            if(ply:KeyDown(IN_USE)||ply:KeyDown(IN_SPEED)) then
                if (!trace.HitPos) then return false end
				if (trace.Entity:IsPlayer()) then return false end

				if ( SERVER && !util.IsValidPhysicsObject( trace.Entity, trace.PhysicsBone ) ) then return false end

				if ( CLIENT ) then return true end
				
				if ( trace.Entity:IsValid() && trace.Entity:GetPhysicsObject():IsValid()) then
				
				   local linktarget=trace.Entity
				   holdinguse=true
				   self:DeselectEnt(trace.Entity)
				   
				   for a,v in ipairs(self.props) do
				   
				       if(v.ent==linktarget) then
				       
				       else
				       
				   
					       local const = constraint.Link( v.ent, linktarget, 0, 0, linkstrength, smartnocollide )
					       undo.AddEntity( const )

					       linkcount=linkcount+1
				       
				       end

				   end
				
				end
				
				
            else
            
				for a,v in ipairs(self.props) do
	                --Msg("!Prop "..a.."!\n")
				    for x=1,10 do

	                    --Msg("Link "..x.."\n")
					    --Msg("There a prop "..a)
					    local closestdistance=99999999
					    local closestprop=-1
					    for b,w in ipairs(self.props) do
							if(a!=b) then
									 local linked=false
									 for i,val in ipairs(links[a]) do
	                                     --Msg("Testing "..b.." against "..val.."\n")
									 	 if(val==b) then
	                                                --Msg("Its linked!\n")
									 	 			linked=true
									 				break
										end
									 end

									 if(!linked) then

									 			 local distance=(v.ent:GetPos()-w.ent:GetPos()):Length()
									             if(distance<closestdistance) then
									             	closestdistance=distance
									             	closestprop=b
									             end
									 end
							end
					    end

					    if(closestprop!=-1) then
					    
					    	--link to this prop and add to link list
					    	if(SLOWMODE) then
										 timer.Simple(WELDTIME*linkcount, self.LinkEnts, self, v.ent,self.props[closestprop].ent,0, 0, linkstrength, smartnocollide,linkcount)
							else
							    self:LinkEnts(v.ent,self.props[closestprop].ent,0, 0, linkstrength, smartnocollide,linkcount)
							end

					    	--[[
					    	if(smartnocollide) then

								local nocollide = constraint.NoCollide( v, self.props[closestprop], 0, 0)
								undo.AddEntity( nocollide )


							end--]]

							linkcount=linkcount+1
	                        --Msg("Linking prop "..a.." to prop "..closestprop.."\n")

							table.insert(links[a],closestprop)


							--[[Msg("Links[ "..a.."]={")

							for o,p in ipairs(links[a]) do
							    Msg(p..",")
							end
							Msg("}\n")--]]

							table.insert(links[closestprop],a)


							--[[Msg("Links[ "..closestprop.."]={")

							for o,p in ipairs(links[closestprop]) do
							    Msg(p..",")
							end
							Msg("}\n")--]]
						else
						    --Msg("Prop "..a.." already linked to\n")
							break
					    end

				    end


				end

				for a,v in ipairs(self.props) do
	                --Msg("!Prop "..a.."!\n")
				    for x=1,10 do

				    	--randomly pick a prop

				    	if(#self.props>1) then

							local b=math.random(#self.props)

							if(b!=a) then

								--test if it has been linked to already
								local linked=false
								 for i,val in ipairs(links[a]) do
		                             --Msg("Testing "..b.." against "..val.."\n")
								 	 if(val==b) then
		                                        --Msg("Its linked!\n")
								 	 			linked=true
								 				break
									end
								 end

		                         --if not, link to it
								 if(!linked) then
								 
								       if(SLOWMODE) then
										 timer.Simple(WELDTIME*linkcount, self.LinkEnts, self, v.ent,self.props[b].ent,0, 0, linkstrength, smartnocollide,linkcount)
										else
										    self:LinkEnts(v.ent,self.props[closestprop].ent,0, 0, linkstrength, smartnocollide,linkcount)
										end

						    		linkcount=linkcount+1

								 	table.insert(links[a],b)

								 	table.insert(links[b],a)

								 	--Msg("Linking prop "..a.." to prop "..b.."\n")

								 end

							 end

				    	end

				    end
				end
				
			end
			
			local nocollidecount=0
			for a,v in ipairs(self.props) do
			
				for b,w in ipairs(self.props) do
					if(a!=b) then
						 local linked=false
						 for i,val in ipairs(links[a]) do
                             --Msg("Testing "..b.." against "..val.."\n")
						 	 if(val==b) then
                                        --Msg("Its linked!\n")
						 	 			linked=true
						 				break
							end
						 end

						 if((!linked)||(!smartnocollide)) then

					 			 local distance=(v.ent:GetPos()-w.ent:GetPos()):Length()
					             if(distance<0) then
					             
					             		--nocollide the ents together
					             		
					             		if(SLOWMODE) then
										 timer.Simple(WELDTIME*(nocollidecount+linkcount), self.NoCollideEnts, self, v.ent,w.ent,0, 0,nocollidecount)
										else
										    self:NoCollideEnts(v.ent,w.ent,0, 0,nocollidecount)
										end
					             		--local nocoll=constraint.NoCollide(v,w,0,0)
										nocollidecount=nocollidecount+1
					             		
					             		--setup their undo
					             		--undo.AddEntity(nocoll)
					             
					             end
					    end
					end
				end
			end
			
			
            
            if(SLOWMODE) then
			 timer.Simple(WELDTIME*(linkcount+nocollidecount), self.LinkingFinished, self,unfreeze,linkcount, holdinguse, self.props,ply)
			else
       			self:LinkingFinished(unfreeze,linkcount,holdinguse, self.props,ply)
			end
	    
	    end
	end
	
	end
	
end

function TOOL:ResetSelection()

		 local ply=self:GetOwner()
		 
		 local propscleared=false
		   --clear the selection
		   if(self.props==nil) then
			      self.props={}
			end
			for a,v in ipairs(self.props) do
					--Msg("V="..v.."\n")
					if(!v.ent:IsValid()) then
						table.remove(self.props,a)
						--Msg("Removing...\n")
					end
			end
			
			if(#self.props>0) then
			   for a,v in ipairs(self.props) do
			       if(v.ent:IsValid()) then
			       	 v.ent:SetColor(v.r,v.g,v.b,v.a)
			       end
				end
				propscleared=true
				
		   end
		   
		   self.props={}
		   return propscleared

end

function TOOL:Reload( trace )
if (!trace.Entity:IsValid()) or (trace.Entity:IsPlayer()) then return end
	if (CLIENT) then return true end
	
	if (!trace.Entity.resources2) then
		self:ClearObjects()
        self:GetOwner():SendLua( "GAMEMODE:AddNotify('Conduit invalid!', NOTIFY_GENERIC, 7);" )
		return
	end
	
	Dev_Unlink_All(trace.Entity)
	
	return true
         

end

function TOOL.BuildCPanel(cp)

    cp:AddControl( "Header", { Text = "#Tool_smartlinker_name", Description	= "#Tool_smartlinker_desc" }  )
    cp:AddControl( "Slider", { Label = "Auto-select Radius:", Description = "The autoselecting radius (hold use and left click to autoselect)",Type = "float", Min = "0", Max = "10000", Command = "smartlinker_radius" } )
	cp:AddControl("Color", {
		Label = "#Tool_smartlinker_colour",
		Red = "Tool_smartlinker_color_r",
		Green = "Tool_smartlinker_color_g",
		Blue = "Tool_smartlinker_color_b",
		ShowAlpha = "0",
		ShowHSV = "1",
		ShowRGB = "1",
		Multiplier = "255"
	})
	
		cp:AddControl("Slider", {
		Label = "#Tool_smartlinker_width",
		Type = "Float",
		Min = "1",
		Max = "20",
		Command = "Tool_smartlinker_width"
	})
	
	cp:AddControl("MaterialGallery", {
		Label = "#Tool_smartlinker_material",
		Height = "64",
		Width = "32",
		Rows = "1",
		Stretch = "1",
		Options = {
			["Link"] = {			Material = "cable/rope_icon",	dev_link_material = "cable/rope" },
			["Cable 2"] = {			Material = "cable/cable_icon",	dev_link_material = "cable/cable2" },
			["XBeam"] = {			Material = "cable/xbeam",		dev_link_material = "cable/xbeam" },
			["Red Laser"] = {		Material = "cable/redlaser",	dev_link_material = "cable/redlaser" },
			["Blue Electric"] = {	Material = "cable/blue_elec",	dev_link_material = "cable/blue_elec" },
			["Physics Beam"] = {	Material = "cable/physbeam",	dev_link_material = "cable/physbeam" },
			["Hydra"] = {			Material = "cable/hydra",		dev_link_material = "cable/hydra" }
		}
	})
end
