TOOL.Category		= "Construction"
TOOL.Name			= "#Zari Exact Align"
TOOL.Command		= nil
TOOL.ConfigName		= ""

TOOL.ClientConVar[ "usePitch" ] = "0"
TOOL.ClientConVar[ "pitch" ] = "0"
TOOL.ClientConVar[ "useYaw" ] = "0"
TOOL.ClientConVar[ "yaw"   ] = "0"
TOOL.ClientConVar[ "useRoll" ] = "0"
TOOL.ClientConVar[ "roll"  ] = "0"

-- Left click -- Adjust
-- Right click -- Set
-- Reload -- Copy

-- Add Default Language translation
if ( CLIENT ) then
	language.Add( "Tool_zariexactalign_name"      , "Exact Align" )
	language.Add( "Tool_zariexactalign_desc"      , "Align an entity precisely" )
	language.Add( "Tool_zariexactalign_0"         , "Left click to adjust the angle, right click to set the angle, reload to copy" )
	
	language.Add( "Tool_zariexactalign_usePitch"     , "Use Pitch" )
	language.Add( "Tool_zariexactalign_pitch"     , "Pitch" )
	
	language.Add( "Tool_zariexactalign_useYaw"       , "Use Yaw" )
	language.Add( "Tool_zariexactalign_yaw"       , "Yaw" )
	
	language.Add( "Tool_zariexactalign_useRoll"      , "Use Roll" )
	language.Add( "Tool_zariexactalign_roll"      , "Roll" )
end
	
	
function TOOL.BuildCPanel( CPanel )
	CPanel:AddControl("Header", { Text = "#Tool_zariexactalign_name", Description = "#tool_zariexactalign_desc" } )
	
	CPanel:AddControl("Checkbox", {Label = "#Tool_zariexactalign_usePitch", Command = "zariexactalign_usePitch"}) 
	CPanel:AddControl("Slider", { Label = "#Tool_zariexactalign_pitch", Type = "Float", Min = "-180", Max = "180", Command = "zariexactalign_pitch" } )
	
	
	CPanel:AddControl("Checkbox", {Label = "#Tool_zariexactalign_useYaw", Command = "zariexactalign_useYaw"})
	CPanel:AddControl("Slider", { Label = "#Tool_zariexactalign_yaw"  , Type = "Float", Min = "-180", Max = "180", Command = "zariexactalign_yaw" } )
	
	
	CPanel:AddControl("Checkbox", {Label = "#Tool_zariexactalign_useRoll", Command = "zariexactalign_useRoll"})
	CPanel:AddControl("Slider", { Label = "#Tool_zariexactalign_roll" , Type = "Float", Min = "-180", Max = "180", Command = "zariexactalign_roll" } )
	
end

-- On primary, adjust the angles.
function TOOL:LeftClick( trace )
	local element = trace.Entity
	if (element:IsValid()) then
		if (!element:IsPlayer()) then	
			local ang = element:GetAngles()
			local newPitch, newYaw, newRoll
			newPitch = ang.p
			newYaw   = ang.y
			newRoll  = ang.r
			
			if(self:GetClientNumber("usePitch", 0)==1) then
				newPitch = newPitch + self:GetClientNumber("pitch", 0)
			end
			if(self:GetClientNumber("useYaw", 0)==1) then
				newYaw = newYaw + self:GetClientNumber("yaw", 0)
			end
			if(self:GetClientNumber("useRoll", 0)==1) then
				newRoll = newRoll + self:GetClientNumber("roll", 0)
			end
			
			element:SetAngles(Angle(newPitch, newYaw, newRoll))
			return true
		end
	end
end

-- On secondary, set the angles.
function TOOL:RightClick( trace )
	local element = trace.Entity
	if (element:IsValid()) then
		if (!element:IsPlayer()) then
			local ang = element:GetAngles()
			local newPitch, newYaw, newRoll
			newPitch = ang.p
			newYaw = ang.y
			newRoll = ang.r

			if(self:GetClientNumber("usePitch", 0)==1) then
				newPitch = self:GetClientNumber("pitch", 0)
			end
			if(self:GetClientNumber("useYaw", 0)==1) then
				newYaw = self:GetClientNumber("yaw", 0)
			end
			if(self:GetClientNumber("useRoll", 0)==1) then
				newRoll = self:GetClientNumber("roll", 0)
			end

			element:SetAngles(Angle(newPitch, newYaw, newRoll))
			return true
		end
	end	
end

-- On reload, copy the angles.
function TOOL:Reload( trace )
	local element = trace.Entity
	if (element:IsValid()) then
		if (!element:IsPlayer()) then
			if (SERVER) then
				local curAngle = element:GetAngles()
				self:GetOwner():ConCommand("zariexactalign_pitch "..tostring(curAngle.p))
				self:GetOwner():ConCommand("zariexactalign_yaw "..tostring(curAngle.y))
				self:GetOwner():ConCommand("zariexactalign_roll "..tostring(curAngle.r))
			end
			return true
		end
	end
end
